package org.ow2.util.ee.metadata.war.impl.configurator;

import java.util.List;

import org.ow2.util.ee.metadata.common.impl.configurator.CommonFieldMetadataConfigurator;
import org.ow2.util.ee.metadata.war.api.IWarClassMetadata;
import org.ow2.util.ee.metadata.war.api.IWarFieldMetadata;
import org.ow2.util.ee.metadata.war.api.IWarMethodMetadata;
import org.ow2.util.ee.metadata.war.impl.WarFieldMetadata;
import org.ow2.util.scan.api.configurator.metadata.specific.ISpecificClassConfigurator;
import org.ow2.util.scan.api.metadata.structures.JField;

/**
 * WarFieldMetadataConfigurator.
 * @author Gael Lalire
 */
public class WarFieldMetadataConfigurator extends
        CommonFieldMetadataConfigurator<IWarClassMetadata, IWarMethodMetadata, IWarFieldMetadata> {

    /**
     * Constructor.
     * @param jField signature
     * @param warClassMetadata parent
     * @param annotationParsingDesactived annotationParsingDesactived
     * @param specificClassConfiguratorList specificClassConfiguratorList
     */
    public WarFieldMetadataConfigurator(
            final JField jField,
            final IWarClassMetadata warClassMetadata,
            final boolean annotationParsingDesactived,
            final List<ISpecificClassConfigurator<IWarClassMetadata, IWarMethodMetadata, IWarFieldMetadata>>
                specificClassConfiguratorList) {
        super(new WarFieldMetadata(jField, warClassMetadata), specificClassConfiguratorList);
        if (!annotationParsingDesactived) {
            registerAnnotationVisitor();
        }
    }

}
